/*
* Code by Bodysoulspirit with the help from Jaymie from Team Vuo. Public Domain.
*/

#include "node.h"

VuoModuleMetadata({
					 "title" : "Get Object Vertices",
					 "description" : "Outputs the vertices of a 3D Object as a 3D Points list. If the Object has children, or transformations applied, use the flatten object boolean.",
					 "keywords" : ["Mesh", "Vertex", "Points", "Scene", "Reinterpret"],
					 "version" : "1.0.2",
});

void nodeEvent
(
	VuoInputData(VuoSceneObject) object,
	VuoInputData(VuoBoolean, {"default":true}) flattenObject,
	VuoOutputData(VuoList_VuoPoint3d) pointsList
)
{
	*pointsList = VuoListCreate_VuoPoint3d();
	VuoSceneObject copy = VuoSceneObject_copy(object);

	if (flattenObject == true){
		VuoSceneObject newObject = VuoSceneObject_flatten(copy);
		VuoMesh m = VuoSceneObject_getMesh(newObject);
		float *positions = 0;
		unsigned int vertexCount = 0;
		VuoMesh_getCPUBuffers(m, &vertexCount, &positions, NULL, NULL, NULL, NULL, NULL);
		for(unsigned int i = 0; i < vertexCount; i++)
		{
			VuoPoint3d currentPoint = (VuoPoint3d){ positions[i*3+0], positions[i*3+1], positions[i*3+2] };
			VuoListAppendValue_VuoPoint3d(*pointsList, currentPoint);
		}
	}

	else if (flattenObject == false){
		VuoMesh m = VuoSceneObject_getMesh(copy);
		float *positions = 0;
		unsigned int vertexCount = 0;
		VuoMesh_getCPUBuffers(m, &vertexCount, &positions, NULL, NULL, NULL, NULL, NULL);
		for(unsigned int i = 0; i < vertexCount; i++)
		{
			VuoPoint3d currentPoint = (VuoPoint3d){ positions[i*3+0], positions[i*3+1], positions[i*3+2] };
			VuoListAppendValue_VuoPoint3d(*pointsList, currentPoint);
		}
	}
}
